RYGEL.CONF(5)

NAME
rygel.conf - Rygel configuration file

SYNOPSIS

$XDG_CONFIG_DIR/rygel.conf

/etc/rygel.conf

DESCRIPTION

rygel reads its configuration values from the file $XDG_CONFIG_DIR/rygel.conf or a file given on command line with the --config option. If that file does not exist it uses the file /etc/rygel.conf.

Most of the options may be overriden by commandline arguments or envronment variables. See rygel(1) for details on those.

GENERAL DIRECTIVES

Lists in the configuration files are separated by a semicolon (;). Boolean values may be either true or false.

ipv6
    Set to false to disable binding to IPv6 addresses

interface=INTERFACE
    Semicolon separated list separated of the network interfaces rygel should listen on. May be an IP, an interface name or on Linux even the ESSID of a wireless network.

port=PORT
    Set the listen-port.

enable-transcoding
    Set to true to enable transcoding in general.

log-level=DOMAIN:LEVEL[,DOMAIN:LEVEL,...]
    Comma-separated list of DOMAIN:LEVEL pairs, allowing to set the log level individually for each domain, where DOMAIN is eiher "*", "rygel" or the name of a plugin. Allowed log levels are 1=error, 2=critical, 3=warning, 4=message/info, 5=debug. Note that on recent versions of GLib (>= 2.36) it is required to set the environment variable G_MESSAGES_DEBUG to all to get any debug output.

plugin-path=PATH
    Set the plugin search path.

engine-path=PATH
    Set the engine search path.

media-engine=ENGINE
    Name of the loadable module to use as media engine back-end.

allow-upload
    Allow uploading of media files via UPnP.

allow-deletion
    Allow remote media file deletion via UPnP.

video-upload-folder
    If allow-upload is true, use this folder to store uploaded videos. It defaults to @VIDEOS@ which expands to the default directory for video files (usually $HOME/Videos).

music-upload-folder
    If allow-upload is true, use this folder to store uploaded music files. It defaults to @MUSIC@ which expands to the default directory for music files (usually $HOME/Music).

picture-upload-folder
    If allow-upload is true, use this folder to store uploaded pictures. It defaults to @PICTURES@ which expands to the default directory for picture files (usually $HOME/Pictures).

force-downgrade-for
    Semicolon-separated list of device user-agents (or parts thereof) which need a forced downgrade to MediaServer:1 and/or ContentDirectory:1.

        Warning
        Only use this parameter if you know what your're doing or are being told to do so; overriding the default value might cause incompatibilites. If you find that adding your device here enables its usage with Rygel, please file an IOP bug[1] so we can include it into the default configuration.

acl-fallback-policy
    This is the default policy that is used if no access control provider is found on the D-Bus. Use true to allow access from every peer, false to deny all access. If it is not specified, the default fall-back policy is true.

strict-dlna
    Disabled by default. Use true to disable a set of features that improve compatibility with many clients, but break standard conformance

DATABASE SETTINGS

The settings in the [Database]section are for the database support library.

debug
    Set to true to show the SQL statements used.

GSTREAMER MEDIA ENGINE SETTINGS

The settings in the [GstMediaEngine] section are specific to the GStreamer media engine, which is the default media engine. See the media-engine setting. These following options are available for the GStreamer[2] media engine.

transcoders
    A semicolon-separated list of the active transcoders. This setting has no effect if enable-transcoding is set to false. Possible values are: lpcm,mp3,mp2ts,aac,avc or wmv. Its default value is lpcm;mp3;mp2ts;aac;wmv.

PLUGIN-SPECIFIC SETTINGS

Sections for plugins are denoted with [PluginName] and can contain options specific to a plugin (see below) as well these common options:

title=TITLE
    Title of the device implemented by this plugin. There are some variables which will be replaced by rygel. @REALNAME@ will be subsituted by the user's real name, @USERNAME@ by the user's login id and @HOSTNAME@ by the name of the machine rygel runs on.

enabled
    You can individually enable or disable plugins by setting this to true or false.

energy-management
    Set to true to if you would like the UPnP device to contain a EnergyManagement service. Note that additional configuration is required, see EnergyManagement settings.

diagnostics
    Set to true if you would like the UPnP device to contain a BasicManagement:2 service that allows running tools like ping, nslookup and traceroute remotely.

server-name
    A string that will be sent as the "Server:" header in a HTTP response.

ENERGYMANAGEMENT SETTINGS

The settings in [EnergyManagement-IFACENAME] sections specify the settings that relate to EnergyManagement services on this interface. Example: [EnergyManagement-eth0].

mode-on-suspend
    The NetworkInterfaceMode that should be used when suspended. Default is "Unimplemented", other valid values are "IP-up-Periodic”, "IP-down-no-Wake", "IP-down-with-WakeOn", "IP-down-with-WakeAuto", "IP-down-with-WakeOnAuto".

supported-transport
    Optional WakeSupportedTransport that the service should advertize. Valid values are "UDP-Broadcast", "UDP-Unicast", "TCP-Unicast", "Other".

password
    Optional hexadecimal password that will be used to build the WakeOnPattern.

TRACKER PLUGIN

The tracker plugin uses the centralized database of meta information from the tracker project. See the tracker project website[3] for more information about tracker.

share-pictures
    Enable or disable sharing of all pictures in the Tracker database.

share-videos
    Enable or disable sharing of all videos in the Tracker database.

share-music
    Enable or disable sharing of all music in the Tracker database.

MEDIAEXPORT PLUGIN

The MediaExport plugin is an alternative to the tracker-backed media export. It extracts meta-data by itself and stores it in a SQLite[4] database in $XDG_CACHE_DIR/rygel/media-export.db on UNIX platforms.

    Note

    If both plugins, Tracker as well as MediaExport are enabled, MediaExport will disable itself in favour of the Tracker plugin.

There are several options supported by this plugin:

uris
    A list of URIS to expose via UPnP. May be files, folders or anything supported by GVFS. If left emtpy it defaults to export the user's music, video and picture folders as defined per XDG special user directories spec. These default folders can be referenced by @MUSIC@, @PICTURES@ and @VIDEOS@. Locations can be entered as either fully escaped URIS or normal paths.

        Note
        If you enter a normal path that contains whitespace there is no need to escape them with either a backslash or putting the string in quotes.

        Note
        It is strongly advised against using an exported folder as a target for downloads when extract-metadata is enabled. Rygel will most likely ignore the files then because they will fail to extract.

    Example 1. Possible values for uris

    uris=@MUSIC@;/home/user/My Pictures;file:///home/user/My%20Videos

extract-metadata
    Set to false if you do not care about duration or any other meta-data like artist. This speeds up the initial crawl of the media a lot. Use it to quickly share some files via UPnP. Make sure to define an include-filter, otherwise you will end up with a lot of files exposed which the client cannot display anyway.

monitor-changes
    Set to false if you don't want to have new files picked up automatically by rygel.

monitor-grace-timeout
    Time in seconds to wait after a new file has been detected before trying to extract meta-data from it. Useful if you're downloading to a directory watched by rygel. Default is 5 seconds.

virtual-folders
    Set to false if you don't need the virtual folder hierarchy.

PLAYBIN PLUGIN

The Playbin plugin implements a media renderer (Digtal Media Renderer, DMR in DLNA terms). This plugin was known as GstRenderer.

It is highly recommended to leave the sink choice to playbin. If, however, the default choices don't work for you they can be reconfigured as follows

audio-sink
    Definition of the audio sink to use. Can be a single element or a partial pipeline definition in gst-launch's syntax

video-sink
    Definition of the video sink to use. Can be a single element or a partial pipeline definition in gst-launch's syntax

LIGHTMEDIASCANNER PLUGIN

The LightMediaScanner plugin exports the contents of the lightmediascanner daemon[5]

This plugin does not have any special options.

GSTLAUNCH PLUGIN

The GstLaunch plugin allows to expose GStreamer pipelines using the same syntax as the gst-launch utilty. You can configure several items in this plugins.

launch-items
    A list of of identifiers for the pipelines to be exposed.

identifier-title
    Title of the device represented by this pipeline. Identifier is the identifier as set in launch-items

identifier-mime
    Mime-type of the pipeline.

identifier-launch
    Definition of the pipeline in gst-launch syntax. For some examples on writing pipelines see gst-launch(1).

identifier-dlnaprofile
    DLNA profile for the stream.

An example configuration is available in the distributed configuration file /etc/rygel.conf.

EXTERNAL

The External plugin is an consumer of the MediaServer2 DBus interface specification[6]. This allows external programs to share their data via UPnP by implementing this DBus specification. The plugin picks up any implementation of this interface on the session bus and exposes the presented media via UPnP. Known implementors of this spec are gnome-dvb-daemon[7], Rhythmbox[8] and Grilo[9] via the grilo-ms2 project.

You can disable the whole functionality by setting enabled=false in the [External] section of the configuration file.

Individual peers may be enabled or disabled by creating sections corresponding to the D-Bus names of the peer:

    [org.gnome.UPnP.MediaServer2.Rhythmbox]
    enabled=false

This plugin has no additional options.

MPRIS

The MPRIS plugin is a consumer of the MPRIS2 DBus interface specification[10]. The implementation conforms to version 2.0 of the standard.

rygel exposes media players that implement the provider side of this DBus specification as DLNA Digital Media Renderers (DMR) similar to the Playbin plugin. This means that you can easily turn your media player into a DMR by implementing this DBus specification.

Players that implement this spec and are known to work with rygel are Banshee[11], Rhythmbox[8] and GNOME Videos (previously known as Totem)[12]

You can disable the whole functionality by setting enabled=false in the [MRPIS] section of the configuration file.

The configuration of this plugin is special. Plugin configuration is not done on the plugin but rather per peer that is found providing the MPRIS2 interface. See the following example to set the title for Banshee on MPRIS:

    [org.mpris.MediaPlayer2.banshee]
    title=@REALNAME@'s Banshee on @HOSTNAME@

This plugin has no additional options.

SEE ALSO

rygel(1), gst-launch(1)

AUTHOR

Jens Georg <mail@jensge.org>
    Wrote this manpage.

NOTES

1.  file an IOP bug
    https://gitlab.gnome.org/GNOME/rygel/issues/new/?issuable_template=IOP

2.  GStreamer
    http://gstreamer.freedesktop.org

3.  tracker project website
    https://wiki.gnome.org/Projects/Tracker

4.  SQLite
    http://sqlite.org

5.  lightmediascanner daemon
    https://github.com/profusion/lightmediascanner

6.  MediaServer2 DBus interface specification
    https://wiki.gnome.org/Projects/Rygel/MediaServer2Spec

7.  gnome-dvb-daemon
    https://wiki.gnome.org/Projects/DVBDaemon

8.  Rhythmbox
    http://www.rhythmbox.org

9.  Grilo
    https://wiki.gnome.org/Projects/Grilo

10. MPRIS2 DBus interface specification
    https://specifications.freedesktop.org/mpris-spec/latest/

11. Banshee
    http://banshee.fm

12. GNOME Videos (previously known as Totem)
    https://wiki.gnome.org/Apps/Videos